<template>
	<view class="container">
		<scroll-view class="content-box" scroll-y="true">
			<view class="user-section">
				<view class="bg"><image src="/static/img/user-bg.png" mode=""></image></view>
				<view class="user-info-box ">
					<view class="detail flex">
						<view class="portrait-box" @click="navTo('/pages/set/userinfo')">
							<image class="portrait" :src="userInfo.avatar || '/static/error/missing-face.png'"></image>
						</view>
						<view class="info-box">
							<view class="info-top flex">
								<view class="username clamp">{{ userInfo.nickname || '游客' }}</view>
								<view class="vip" v-if="userInfo.level > 0">
									<image class="vip-bg" src="../../static/img/vip.png" mode=""></image>
									<view class="vip-title">{{ userInfo.level_info.name }}</view>
								</view>
							</view>
							<view class="font-size-sm">{{ userInfo.account }}</view>
						</view>
					</view>
					<view class="my-info flex" @click="navTo('/pages/set/userinfo')" v-if="hasLogin">
						<image src="../../static/icon/i6.png" mode=""></image>
						<view class="title">设置</view>
					</view>
				</view>
			</view>
			<!-- 订单 -->
			<view class="item-box item-box-b">
				<view class="box-title flex borde-b">
					<view class="title"><text>我的订单</text></view>
					<view class="link" @click="navTo('/pages/order/order?state=0')" hover-class="common-hover"><text class="iconfont iconenter"></text></view>
				</view>
				<view class="order-section">
					<view class="order-item" @click="navTo('/pages/order/order?state=0')" hover-class="common-hover" :hover-stay-time="50">
						<view class=" icon position-relative">
							<image class="icon-img" src="/static/user/order1.png" mode="aspectFit"></image>
							<view class="corner" v-if="orderInfo.unpaid_count > 0">
								<text>{{ orderInfo.unpaid_count }}</text>
							</view>
						</view>
						<text>待付款</text>
					</view>
					<view class="order-item" @click="navTo('/pages/order/order?state=1')" hover-class="common-hover" :hover-stay-time="50">
						<view class=" icon position-relative">
							<image class="icon-img" src="/static/user/order2.png" mode="aspectFit"></image>
							<view class="corner" v-if="orderInfo.unshipped_count > 0">
								<text>{{ orderInfo.unshipped_count }}</text>
							</view>
						</view>
						<text>待发货</text>
					</view>
					<view class="order-item" @click="navTo('/pages/order/order?state=2')" hover-class="common-hover" :hover-stay-time="50">
						<view class="icon position-relative">
							<image class="icon-img" src="/static/user/order3.png" mode="aspectFit"></image>
							<view class="corner" v-if="orderInfo.received_count > 0">
								<text>{{ orderInfo.received_count }}</text>
							</view>
						</view>
						<text>待收货</text>
					</view>
					<view class="order-item" @click="navTo('/pages/order/order?state=4')" hover-class="common-hover" :hover-stay-time="50">
						<view class="icon position-relative"><image class="icon-img" src="/static/user/order4.png" mode="aspectFit"></image></view>
						<text>已完成</text>
					</view>
				</view>
			</view>
			<view>
				<view class="item-box item-box-a">
					<view class="order-section">
						<view class="order-item" @click="navTo('/pages/money/wallet')" hover-class="common-hover" :hover-stay-time="50">
							<view class="icon icon-b"><image class="icon-img" src="/static/user/yue.png" mode="aspectFit"></image></view>
							<view class="order-font">收益中心</view>
						</view>
						<view class="order-item" @click="navTo('/pages/user/award')" hover-class="common-hover" :hover-stay-time="50">
							<view class="icon icon-b"><image class="icon-img" src="/static/user/yongjin.png" mode="aspectFit"></image></view>
							<view class="order-font">我的钱包</view>
						</view>
						<view class="order-item" @click="navTo('/pages/user/shareQrCode')" hover-class="common-hover" :hover-stay-time="50">
							<view class="icon icon-b"><image class="icon-img" src="/static/user/yaoqing.png" mode="aspectFit"></image></view>
							<view class="order-font">邀请有礼</view>
						</view>
						<view class="order-item" @click="navTo('/pages/user/team')" hover-class="common-hover" :hover-stay-time="50">
							<view class="icon icon-b"><image class="icon-img" src="/static/user/tuiguang.png" mode="aspectFit"></image></view>
							<view class="order-font">我的推广</view>
						</view>
					</view>
				</view>
				<view class="history-section icon">
					<uni-list>
						<uni-list-item title="我的收藏" @click="navTo('/pages/user/favorites')" thumb="/static/user/shoucang.png"></uni-list-item>
						<uni-list-item title="收货地址" @click="navTo('/pages/set/address')" thumb="/static/user/dizhi.png"></uni-list-item>
						<uni-list-item title="联系客服" @click="showPopup" thumb="/static/user/kefu.png"></uni-list-item>
					</uni-list>
				</view>
			</view>
		</scroll-view>
		<uni-popup ref="popup" type="center">
			<view class="popup">
				<view class="popup-dox">
					<image class="popup-logo" src="../../static/img/img009.png"></image>
					<view class="pop-title">已为您定制专属客服</view>
					<view>{{ weixin }}</view>
					<image class="popup-text" @longtap="bc_code" :src="erweima"></image>
					<view class="btn" @click="copy(weixin)">复制微信号</view>
					<view class="pop-tip flex">
						<view class="weixin"><image src="../../static/img/weixin.png" mode=""></image></view>
						<view>长按保存二维码</view>
					</view>
				</view>
			</view>
			<view class="close_icon" @click="close"><image src="../../static/img/Close.png"></image></view>
		</uni-popup>
	</view>
</template>
<script>
import { mapState, mapMutations } from 'vuex';
import uniList from '@/components/uni-list/uni-list.vue';
import uniListItem from '@/components/uni-list-item/uni-list-item.vue';
import { orderData, getUserInfo, getMyStore,service } from '@/api/user.js';
import { saveUrl, interceptor } from '@/utils/loginUtils.js';
import { logout } from '@/api/set.js';
// import uniCopy from '@/js_sdk/xb-copy/uni-copy.js';
let startY = 0,
	moveY = 0,
	pageAtTop = true;
export default {
	components: {
		uniList,
		uniListItem
	},
	data() {
		return {
			coverTransform: 'translateY(0px)',
			coverTransition: '0s',
			moving: false,
			userDowm: 0, //卡片升级专属高度
			userMaxDowm: 0, //卡片最高高度
			erweima: '',
			weixin: '',
		};
	},
	onShow() {
		// 判断是否已经登录
		if (this.hasLogin) {
			this.loadBaseData();
			
			this.getMyStore();
		}
	},
	onReady() {
		// 初始化获取页面宽度
		uni.createSelectorQuery()
			.select('.container')
			.fields(
				{
					size: true
				},
				data => {
					// 计算最多下拉的高度
					this.userDowm = Math.floor((data.width / 750) * 185);
					// 计算最大触发修改高度事件
					this.userMaxDowm = Math.floor((data.width / 750) * 250);
				}
			)
			.exec();
	},
	// #ifndef MP
	// onNavigationBarButtonTap(e) {
	// 	const index = e.index;
	// 	if (index === 0) {
	// 		this.navTo('/pages/set/set');
	// 	} else if (index === 1) {
	// 		// #ifdef APP-PLUS
	// 		const pages = getCurrentPages();
	// 		const page = pages[pages.length - 1];
	// 		const currentWebview = page.$getAppWebview();
	// 		currentWebview.hideTitleNViewButtonRedDot({
	// 			index
	// 		});
	// 		// #endif
	// 		uni.navigateTo({
	// 			url: '/pages/user/notice'
	// 		});
	// 	}
	// },
	// #endif
	computed: {
		...mapState('user', ['userInfo', 'orderInfo', 'hasLogin'])
	},
	methods: {
		...mapMutations('user', ['setUserInfo', 'logout']),
		copy(content) {
			/**
			 * 小程序端 和 app端的复制逻辑
			 */
			//#ifndef H5
			uni.setClipboardData({
				data: content,
				success: function() {
					console.log('success');
					return true;
				}
			});
			//#endif

			/**
			 * H5端的复制逻辑
			 */
			// #ifdef H5
			if (!document.queryCommandSupported('copy')) {
				//为了兼容有些浏览器 queryCommandSupported 的判断
				// 不支持
				return false;
			}
			let textarea = document.createElement('textarea');
			textarea.value = content;
			textarea.readOnly = 'readOnly';
			document.body.appendChild(textarea);
			textarea.select(); // 选择对象
			textarea.setSelectionRange(0, content.length); //核心
			let result = document.execCommand('copy'); // 执行浏览器复制命令
			textarea.remove();
			return result;
			// #endif
		},
		bc_code() {
			let that = this;
			console.log('保存二维码', this.erweima);
			uni.downloadFile({
				//获得二维码的临时地址
				url: this.erweima,
				success: res => {
					//console.log('获取url',res)
					if (res.statusCode == 200) {
						uni.saveImageToPhotosAlbum({
							filePath: res.tempFilePath, //传入临时地址
							success() {
								that.$api.msg('保存成功'); //封装的提示
							},
							fail() {
								that.$api.msg('保存失败');
							}
						});
					}
				}
			});
		},
		showPopup() {
			this.$refs.popup.open();
		},
		close() {
			this.$refs.popup.close();
		},
		comfirm(text) {
			console.log(text);
			const result = this.uniCopy(text);
			if (result === false) {
				uni.showToast({
					title: '不支持'
				});
			} else {
				uni.showToast({
					title: '复制成功',
					icon: 'none'
				});
			}
			this.$refs.popup.close();
		},
		...mapMutations('user', ['setUserInfo', 'setOrderInfo']),
		// 加载初始数据
		loadBaseData() {
			getUserInfo({})
				.then(({ data }) => {
					console.log(data, 'userInfo+++++++++++++++++++');
					this.setUserInfo(data);
					// 获取用户数据完毕后在获取订单数据防止多次跳转到登录页
					orderData({})
						.then(({ data }) => {
							this.setOrderInfo(data);
						})
						.catch(e => {
							this.setOrderInfo({
								complete_count: 0, //完成
								received_count: 0, //待收货
								unshipped_count: 0, //待发货
								order_count: 0, //订单总数
								unpaid_count: 0 //待付款
							});
						});
				})
				.catch(e => {
					console.log(e);
				});
			service({}).then(({ data }) => {
				this.erweima = data.service_qr;
				this.weixin = data.service_wechat;
			});
		},
		/**
		 * 统一跳转接口,拦截未登录路由
		 * navigator标签现在默认没有转场动画，所以用view
		 */
		navTo(url) {
			if (!this.hasLogin) {
				// 保存地址
				saveUrl();
				// 登录拦截
				interceptor();
			} else {
				uni.navigateTo({
					url
				});
			}
		},

		/**
		 *  会员卡下拉和回弹
		 *  1.关闭bounce避免ios端下拉冲突
		 *  2.由于touchmove事件的缺陷（以前做小程序就遇到，比如20跳到40，h5反而好很多），下拉的时候会有掉帧的感觉
		 *    transition设置0.1秒延迟，让css来过渡这段空窗期
		 *  3.回弹效果可修改曲线值来调整效果，推荐一个好用的bezier生成工具 http://cubic-bezier.com/
		 */
		coverTouchstart(e) {
			// console.log(e);
			if (pageAtTop === false) {
				return;
			}

			this.coverTransition = 'transform .1s linear';
			startY = e.touches[0].clientY;
		},
		coverTouchmove(e) {
			// console.log(e);
			moveY = e.touches[0].clientY;
			let moveDistance = moveY - startY;
			let maxDowm = this.userMaxDowm;
			let Dowm = this.userDowm;
			if (moveDistance < 0) {
				this.moving = false;
				return;
			}
			this.moving = true;
			if (moveDistance >= Dowm && moveDistance < maxDowm) {
				moveDistance = Dowm;
			}

			if (moveDistance > 0 && moveDistance <= Dowm) {
				this.coverTransform = `translateY(${moveDistance}px)`;
			}
		},
		coverTouchend() {
			if (this.moving === false) {
				return;
			}
			this.moving = false;
			this.coverTransition = 'transform 0.3s cubic-bezier(.21,1.93,.53,.64)';
			this.coverTransform = 'translateY(0px)';
		},
		getMyStore() {
			getMyStore().then(res => {
				console.log('getMyStore', res);
			});
		},
		outlogin() {
			let obj = this;
			uni.showModal({
				content: '确定要退出登录么',
				success: e => {
					if (e.confirm) {
						logout({})
							.then(e => {
								obj.logout();
								uni.navigateTo({
									url: '/pages/public/login'
								});
							})
							.catch(e => {
								console.log(e);
							});
					}
				}
			});
		}
	}
};
</script>
<style lang="scss">
page {
	height: 100%;
	background-color: $page-color-base;
}

%flex-center {
	display: flex;
	flex-direction: column;
	justify-content: center;
	align-items: center;
}

%section {
	display: flex;
	justify-content: space-around;
	align-content: center;
	background: #fff;
	border-radius: 10rpx;
}

.container {
	height: 100%;
	background-color: #fff;
}

.content-box {
	height: 100%;
}

.user-section {
	height: 420rpx;
	padding: 50rpx 0rpx 0 30rpx;
	position: relative;

	.bg {
		position: absolute;
		left: 0;
		top: 0;
		width: 100%;
		height: 100%;
		background: linear-gradient(180deg, #08c4e6, #50ead2);
		// z-index: 1;
		// background-color: $base-color;
		image {
			width: 100%;
			height: 100%;
		}
	}
}

.user-info-box {
	height: 180rpx;
	color: white;
	display: flex;
	align-items: center;
	justify-content: space-between;
	position: relative;
	z-index: 1;

	.detail {
		height: 130rpx;

		.portrait-box {
			height: 100%;

			.portrait {
				width: 130rpx;
				height: 100%;
				border: 5rpx solid #fff;
				border-radius: 50%;
			}
		}

		.info-box {
			margin-left: 20rpx;
			line-height: 1.5;

			.username {
				font-size: $font-lg + 2rpx;
				height: 100%;
				max-width: 200rpx;
			}
			.vip {
				position: relative;
				margin-left: 12rpx;
				width: 120rpx;
				height: 40rpx;
				.vip-bg {
					position: absolute;
					top: 0;
					left: 0;
					right: 0;
					width: 100%;
					height: 100%;
				}
				.vip-title {
					position: relative;
					z-index: 10;
					font-size: 20rpx;
					font-family: PingFang SC;
					font-weight: 500;
					color: #93794b;
					padding-left: 36rpx;
					line-height: 40rpx;
				}
			}

			.username-t {
				font-size: $font-lg + 6rpx;
				// height: 32rpx;
				display: flex;
				align-items: center;

				image {
					display: inline-block;
					margin-left: 10rpx;
					width: 147rpx;
					height: 32rpx;
				}
			}

			.user-get {
				font-size: $font-lg;

				text {
					font-size: $font-lg + 6rpx;
				}
			}
		}
	}

	.config {
		font-size: 48rpx;
		height: 130rpx;

		.setting {
			margin-right: 51rpx;
		}
	}

	.my-info {
		margin-right: 30rpx;
		width: 130rpx;
		height: 50rpx;
		border: 1px solid #ffffff;
		border-radius: 26rpx;
		justify-content: center;

		image {
			width: 30rpx;
			height: 30rpx;
		}

		.title {
			padding-left: 9rpx;
			font-size: 24rpx;
			font-family: PingFang SC;
			font-weight: 500;
			color: #ffffff;
		}
	}
}

.vip-card-box {
	display: flex;
	flex-direction: column;
	color: #f7d680;
	height: 240rpx;
	background: linear-gradient(left, rgba(0, 0, 0, 0.7), rgba(0, 0, 0, 0.8));
	border-radius: 16rpx 16rpx 0 0;
	overflow: hidden;
	position: relative;
	padding: 20rpx 24rpx;

	.card-bg {
		position: absolute;
		top: 20rpx;
		right: 0;
		width: 380rpx;
		height: 260rpx;
	}

	.b-btn {
		position: absolute;
		right: 20rpx;
		top: 16rpx;
		width: 132rpx;
		height: 40rpx;
		text-align: center;
		line-height: 40rpx;
		font-size: 22rpx;
		color: #36343c;
		border-radius: 20px;
		background: linear-gradient(left, #f9e6af, #ffd465);
		z-index: 1;
	}

	.tit {
		font-size: $font-base + 2rpx;
		color: #f7d680;
		margin-bottom: 28rpx;

		.iconfont {
			color: #f6e5a3;
			margin-right: 16rpx;
		}
	}

	.e-b {
		font-size: $font-sm;
		color: #d8cba9;
		margin-top: 10rpx;
	}
}

.cover-container {
	background: $page-color-base;
	margin-top: -150rpx;
	padding: 0 30rpx;
	position: relative;
	background: #f5f5f5;
	padding-bottom: 20rpx;

	.arc {
		position: absolute;
		left: 0;
		top: -34rpx;
		width: 100%;
		height: 36rpx;
	}
}

.tj-sction {
	@extend %section;

	.tj-item {
		@extend %flex-center;
		flex-direction: column;
		height: 140rpx;
		font-size: $font-sm;
		color: #75787d;
	}

	.num {
		font-size: $font-lg;
		color: $font-color-dark;
		margin-bottom: 8rpx;
	}
}

.item-box {
	// width: 710rpx;
	// height: 221rpx;
	// background: #FFFFFF;
	// box-shadow: 0px 0px 20rpx 0px rgba(50, 50, 52, 0.06);
	// border-radius: 20rpx;
	// position: relative;
	// top: -150rpx;
	// left: 0;
	// right: 0;
	// margin: 0 auto -150rpx;
	margin: 20rpx 0;

	.box-title {
		background-color: #fff;
		line-height: 1;
		// padding: 30rpx;
		padding: 0 36rpx 0 35rpx;
		height: 73rpx;
		border-radius: 20rpx 20rpx 0 0;

		.title {
			font-weight: bold;
			font-size: 30rpx;
			font-family: PingFang SC;
			font-weight: bold;
			color: #333333;
		}

		.link {
			font-size: $font-base - 2rpx;
			color: $font-color-light;
		}
	}

	.order-section {
		height: 146rpx;
		@extend %section;

		// padding: 28rpx 0;
		.order-item {
			@extend %flex-center;
			width: 120rpx;
			height: 146rpx;
			border-radius: 10rpx;
			font-size: $font-sm;
			color: $font-color-dark;
		}

		.iconfont {
			font-size: 48rpx;
			margin-bottom: 18rpx;
			color: #fa436a;
		}

		.icon-shouhoutuikuan {
			font-size: 44rpx;
		}

		.icon {
			height: 50rpx;
			width: 48rpx;
			margin-bottom: 18rpx;
			background-size: 100%;
			background-repeat: no-repeat;
			background-position: center;

			.icon-img {
				width: 100%;
				height: 100%;
			}
		}

		.icon-b {
			height: 90rpx;
			width: 88rpx;
		}
	}
}

.history-section {
	// padding: 30rpx 0 0;
	margin-top: 20rpx;
	background: #fff;
	border-radius: 10rpx;

	.sec-header {
		display: flex;
		align-items: center;
		font-size: $font-base;
		color: $font-color-dark;
		line-height: 40rpx;
		margin-left: 30rpx;
		padding-top: 30rpx;

		.iconfont {
			font-size: 44rpx;
			color: $color-red;
			margin-right: 16rpx;
			line-height: 40rpx;
		}
	}

	.h-list {
		white-space: nowrap;
		padding: 30rpx 30rpx 0;

		.h-list-image {
			display: inline-block;
			width: 160rpx;
			height: 160rpx;
			margin-right: 20rpx;
			border-radius: 10rpx;
		}
	}
}

.up-box {
	margin: 21rpx auto;
	width: 710rpx;
	height: 90rpx;
	background: linear-gradient(73deg, #ffffff 0%, #fffbeb 0%, #fff1da 0%, #fed591 100%);
	border-radius: 20rpx;

	image {
		width: 100%;
		height: 100%;
		border-radius: 20rpx;
	}
}

.item-box-b {
	width: 710rpx;
	height: 221rpx;
	background: #ffffff;
	box-shadow: 0px 0px 20rpx 0px rgba(50, 50, 52, 0.5);
	border-radius: 20rpx;
	position: relative;
	top: -150rpx;
	left: 0;
	right: 0;
	margin: 0 auto -150rpx;
}

.popup {
	width: 640rpx;
	background-color: #ffffff;
	border-radius: 15rpx;
	text-align: center;
	.popup-dox {
		position: relative;
		top: -60rpx;
		.popup-logo {
			width: 460rpx;
			height: 132rpx;
		}
		.pop-title {
			font-size: 40rpx;
			font-weight: bold;
			color: #333333;
			padding: 25rpx 0rpx;
			margin-bottom: 50rpx;
		}
		.popup-text {
			width: 400rpx;
			height: 400rpx;
			margin-bottom: 50rpx;
		}
		.btn {
			width: 300rpx;
			height: 50rpx;
			line-height: 50rpx;
			background: #96e4f2;
			margin: 0 auto;
			color: #ffffff;
			border-radius: 25rpx;
		}
		.pop-tip {
			font-size: 30rpx;
			font-weight: 500;
			color: #333333;
			justify-content: center;
			margin-top: 20rpx;
			.weixin {
				width: 48rpx;
				height: 40rpx;
				margin-right: 14rpx;
				image {
					width: 48rpx;
					height: 40rpx;
				}
			}
		}
	}
}
.close_icon {
	width: 60rpx;
	height: 60rpx;
	margin: 88rpx auto 0;
	image {
		width: 100%;
		height: 100%;
	}
}
.outlogin {
	margin: 40rpx auto;
	width: 500rpx;
	background-color: #fff;
	color: #ff4c4b;
	border: 1px solid #ff4c4b;
	text-align: center;
	padding: 10rpx 0rpx;
	border-radius: 50rpx;
}
.order-font {
	margin-top: -24rpx;
}
</style>
